fn main() {
    let input = std::fs::read_to_string("input.txt").unwrap();

    let result = calibration_value(&input);

    println!("Result: {}", result);
}

const VALUES: [&str; 18] = [
    "1", "2", "3", "4", "5", "6", "7", "8", "9", "one", "two", "three", "four", "five", "six",
    "seven", "eight", "nine",
];

fn calibration_value(input: &str) -> u32 {
    input
        .lines()
        .map(|line| {
            let (_, first) = VALUES
                .iter()
                .enumerate()
                .filter_map(|(vi, s)| line.find(s).map(|ri| (ri, (vi % 9) as u32 + 1)))
                .min_by_key(|(i, _v)| *i)
                .unwrap();
            let (_, last) = VALUES
                .iter()
                .enumerate()
                .filter_map(|(vi, s)| line.rfind(s).map(|ri| (ri, (vi % 9) as u32 + 1)))
                .max_by_key(|(i, _v)| *i)
                .unwrap();

            dbg!(first * 10 + last)
        })
        .sum()
}

#[cfg(test)]
mod tests {
    use crate::calibration_value;

    const EXAMPLE_PART_1: &str = "1abc2\npqr3stu8vwx\na1b2c3d4e5f\ntreb7uchet";
    const EXAMPLE_PART_2: &str = "two1nine\neightwothree\nabcone2threexyz\nxtwone3four\n4nineeightseven2\nzoneight234\n7pqrstsixteen";

    #[test]
    fn example_part_1() {
        let result = calibration_value(EXAMPLE_PART_1);
        assert_eq!(142, result);
    }

    #[test]
    fn example_part_2() {
        let result = calibration_value(EXAMPLE_PART_2);
        assert_eq!(281, result);
    }
}
